SystemOrganization addCategory: #PQTestJsonRPC!

Object subclass: #ArithArg
	instanceVariableNames: 'A B'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PQTestJsonRPC'!

!ArithArg methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 23:56'!
a
	^ A! !

!ArithArg methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 23:56'!
a: anObject
	A := anObject! !

!ArithArg methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 23:56'!
b
	^ B! !

!ArithArg methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 23:56'!
b: anObject
	B := anObject! !

Object subclass: #PQJsonRPCReq
	instanceVariableNames: 'jsonrpc method params id'
	classVariableNames: 'idSeq'
	poolDictionaries: ''
	category: 'PQTestJsonRPC'!

PQJsonRPCReq subclass: #ArithReq
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PQTestJsonRPC'!

!ArithReq class methodsFor: 'instance creation' stamp: 'PhilippeQuesnel 3/24/2014 12:27'!
multiply: arithArg
	| req |
	req := self new.
	req method: 'Arith.Multiply'.
	req params: { arithArg }. "golang jsonrpc is ver 1, needs to be array"
	^ req.
	! !

!PQJsonRPCReq class methodsFor: 'as yet unclassified' stamp: 'PhilippeQuesnel 3/24/2014 12:35'!
initialize
	super initialize.
	idSeq := 0.! !

!PQJsonRPCReq class methodsFor: 'as yet unclassified' stamp: 'PhilippeQuesnel 3/24/2014 12:34'!
nextId
	"returns a new Id"
	^ idSeq := idSeq + 1.
! !

!PQJsonRPCReq methodsFor: 'as yet unclassified' stamp: 'PhilippeQuesnel 3/24/2014 16:54'!
asDictionary
	^ Dictionary new
		at: #id put: id;
		at: #method put: method;
		at: #params put: params;
		yourself! !

!PQJsonRPCReq methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 12:29'!
id
	^ id! !

!PQJsonRPCReq methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 12:29'!
id: anObject
	id := anObject! !

!PQJsonRPCReq methodsFor: 'initialization' stamp: 'PhilippeQuesnel 3/22/2014 00:58'!
initialize
	super initialize.
	"jsonrpc := '2.0'."	"note: golang jsonrpc is NOT 2.0 !!"
	id := self class nextId.! !

!PQJsonRPCReq methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 12:30'!
jsonrpc
	^ jsonrpc! !

!PQJsonRPCReq methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 12:30'!
jsonrpc: anObject
	jsonrpc := anObject! !

!PQJsonRPCReq methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 12:30'!
method
	^ method! !

!PQJsonRPCReq methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 12:30'!
method: anObject
	method := anObject! !

!PQJsonRPCReq methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 12:30'!
params
	^ params! !

!PQJsonRPCReq methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 12:30'!
params: anObject
	params := anObject! !

!PQJsonRPCReq methodsFor: 'as yet unclassified' stamp: 'PhilippeQuesnel 3/24/2014 16:54'!
toJSON
	"convert to JSON string"
	^ String
		streamContents: [ :stream | 
			(NeoJSONWriter on: stream)
				"mapInstVarsFor: PQJsonRPCReq;"
				mapInstVarsFor: ArithArg;
				nextPut: self asDictionary ]! !

Object subclass: #TestJsonRPC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PQTestJsonRPC'!

!TestJsonRPC methodsFor: 'as yet unclassified' stamp: 'PhilippeQuesnel 3/24/2014 12:22'!
callArith: arithReq
	"call the jsonrpc Arith server, return the result json string"
	| socket resp |

	[ "connect to server"
	socket := Socket newTCP.
	socket connectTo: NetNameResolver localHostAddress port: 8222.
	socket waitForConnectionFor: 1.	
	
	"send request"
	socket sendData: arithReq toJSON.	
	
	"read response"
	resp := socket receiveData.
	
	] ensure: [socket closeAndDestroy].

	^ resp.
! !

!TestJsonRPC methodsFor: 'as yet unclassified' stamp: 'PhilippeQuesnel 3/24/2014 12:38'!
createArithReq
	| args |
	"create ArithArg parameter for Arith.Multiply"
	args := ArithArg new.
	args a: 20.
	args b: 21.
	
	"prepare jsonrpc request object"
	^ ArithReq multiply: args.
! !

!TestJsonRPC methodsFor: 'as yet unclassified' stamp: 'PhilippeQuesnel 3/24/2014 12:41'!
testMult
	"test jsonrpc call Arith.Multiply"

	| multReq response |
	multReq := self createArithReq.
	response := self callArith: multReq.
	Transcript show: response; cr.! !
PQJsonRPCReq initialize!
